#include "c:\temp\lib\graficos.h"
/* Turbo C++ 3.0     */
/* Oswaldo Varela C. */
typedef char byte;
typedef unsigned int word;
void fskip(FILE *fp,int n){
	for (int i=0;i<n;i++)fgetc(fp);}

void load_bmp(int ,int , char *, int);

/*************************** MAIN ******************************************/
void main(){
	cout << "Este programa desplegar el grafico: raton.bmp"<<endl;
	cout << "Presione una tecla...";getch();
	grafo.open(2);
	// el argumento enviado en .open() indica la resolucion deseada:
	//RESOLUCIONES: 0=320x200; 1=640x400; 2=640x480; 3=800x600; 4=1024x768
	load_bmp(50,50,"\\temp\\texr1.bmp",-1); 	// 50,50 es la esquina superior izquierda
												// donde se desea cargar la imagen.
												// -1 es el desplazamiento, en ciertas
												// ocasiones el bitmap suele cargarse
												// desplazado por complicaciones en su
												// formato, para esto variamos el despla-
												// zamiento entre -3 y 3 hasta que el
												// bitmap se cargue correctamente.
	getch();
}

// Recuerde que esta funcin carga Bitmaps de 256 colores solamente
// No se tiene restricciones de memoria pues se dibuja directamente a pantalla.
void load_bmp(int x1,int y1,char *file,int desp){
	word width, height;
	byte paleta[256*3];
	FILE *fp;int x,num_colors,index;
	if ((fp = fopen(file,"rb")) == NULL) {
	printf("Error al abrir el archivo %s.\n",file);return;}
	if (fgetc(fp)!='B' || fgetc(fp)!='M'){
	fclose(fp);printf("%s no es un archivo bitmap.\n",file);return;}
	// lee el ancho del bitmap
	fskip(fp,16);fread(&width, sizeof(word), 1, fp);
	// lee el alto del bitmap
	fskip(fp,2);fread(&height,sizeof(word), 1, fp);
	// lee el numero de colores
	fskip(fp,22);fread(&num_colors,sizeof(word), 1, fp);fskip(fp,6);
	if (num_colors==0) num_colors=256;
	// lee la paleta del archivo
	for(index=0;index<num_colors;index++){
	paleta[(int)(index*3+2)] = fgetc(fp) >> 2;
	paleta[(int)(index*3+1)] = fgetc(fp) >> 2;
	paleta[(int)(index*3+0)] = fgetc(fp) >> 2;x=fgetc(fp);}
	// setea la paleta de colores
	outportb(0x3c8, 0);
	for(int i = 0; i < 256*3; i++)  outportb(0x3c9, paleta[i]);
	// dibuja el bitmap en pantalla
	for(index=height-1;(index>=0)&&(!feof(fp));index--)
	for(x=0;(x<=width+desp)&&(!feof(fp));x++)
	putpixel(x1+x,y1+index,fgetc(fp));
	fclose(fp);
}
//@2000