/* Turbo C++ 3.0     */
/* Oswaldo Varela C. */
/* La clase GRAFICOS controla la inicializacin y destruccin del modo
	grfico con 256 colores.*/
#if !defined(__GRAFICOS_H)
#define __GRAFICOS_H
#include "graphics.h"
#include "conio.h"
#include "iostream.h"
#include "stdlib.h"
#include "dos.h"
#include "stdio.h"
//****************************************************************************
int huge detectar(void);
/////////////////////////////////////////////////////////////////////////////
//******************* objeto GRAFICOS *****************************************
class GRAFICOS{
	int GraphDriver,GraphMode,ErrorCode;
	static int modosugerido,vmaxx,vmaxy;
	public:
		friend int huge detectar(void);
		~GRAFICOS();
		static int maxx(){return(vmaxx);}
		static int maxy(){return(vmaxy);}
		void open(int);
};
//**************************************************************************
int GRAFICOS::modosugerido;
int GRAFICOS::vmaxx=0;
int GRAFICOS::vmaxy=0;
//******************* cierra el modo grafico y limpia pantalla ***************
GRAFICOS::~GRAFICOS(){
	closegraph();textcolor(7);textbackground(0);clrscr();}
//****************** inicializa modo grafico *********************************
void GRAFICOS::open(int res){
	if ((res<0)||(res>4)) {cout<<"Resolucion inexistente";return;}
	modosugerido=res;//RESOLUCIONES: 0=320x200; 1=640x400; 2=640x480; 3=800x600; 4=1024x768
	GraphDriver = installuserdriver("SVGA256",detectar); //instala SVGA256.bgi
	GraphDriver = DETECT; 		/* Request auto-detection	*/
	initgraph( &GraphDriver, &GraphMode,"\\temp\\bgi");
	ErrorCode = graphresult();		/* Read result of initialization*/
	if( ErrorCode != grOk ){		/* Error occured during init	*/
	cout<<" Error en Sistema Grafico: "<<grapherrormsg( ErrorCode );getch();exit(1);}
	vmaxx=getmaxx();vmaxy=getmaxy();
}
//***********************funcion para ayudar a instalar driver ***************
int huge detectar(void){
	return (GRAFICOS::modosugerido);
}
//**************************************************************************
GRAFICOS grafo; //define objeto global
//***************************************************************************

#endif
//@2000